var dfe58000_ManifestacaoDestinatario_Controller = function(General, templateManager, ScreenService, Dfe58000_ManifestacaoDestinatario_Service, ZhFilterPreferences) {
    

    
    var messages = {
        confirmaDesconhecimento: 'Atenção! Após confirmar a operação não será mais possível importar o XML da mesma. Deseja confirmar a operação?',
        nenhumaNota: 'Não é possivel realizar a operação para a(s) nota(s) selecionadas.',
        confirmarOperacao: 'Atenção! Deseja confirmar a operação para todas as notas marcadas?'
        
    };
    
    var CDEMPRESA;
    var CDINSCESTA;
    
    this.setDefaultFilter = function(args) {
        var widget     = args.owner;
        var currentRow = widget.currentRow;
        var row        = { CDFILIAL: getLocalVar('CDFILIAL')};
        General.callRestEngine("df_entrada#/defaultFilterManif", "Row", row).then((defaultFilter) =>  {
            defaultFilter = defaultFilter.dataset.defaultFilter;
            var filter = Util.clone(currentRow, ["__rightActions", "__leftActions"]);
            for(var key in defaultFilter) {
                if(key == 'DTEMISSAO') {
                    filter.DTEMISSAO = {
                        start:  defaultFilter[key],
                        period: undefined,
                        end:    defaultFilter[key]
                    };
                }
                else {
                    filter[key] = defaultFilter[key];
                }
            }
            widget.getField('NRINSJURIEST').readOnly    = false;
            widget.getField('CDINSCESTA').readOnly      = false;
            ZhFilterPreferences.setOriginalFilter(widget.id, filter);
            ZhFilterPreferences.openFilterWidget(widget, filter);
            this.coloreLegenda(widget);
        },
        (error) => {
            ZhFilterPreferences.openFilterWidget(widget);
            this.coloreLegenda(widget);
        });
    };
    
    var requestError = function(error){
        var errorMessage = "Ocorreu um erro ao tentar realizar a operação.";
        if (error && error.data) {
            errorMessage = error.data.error;
        }
        ScreenService.showMessage(errorMessage, "ERROR");
    };
    
    this.coloreLegenda = function(widgetGrid){
        var widget = widgetGrid.container.getWidget('legendaStripe');
        widget.getField('LEGENDAGRAY').element[0].style.color = 'gray';
        widget.getField('LEGENDARED').element[0].style.color = 'red';
        widget.getField('LEGENDAGREEN').element[0].style.color = 'green';
        widget.getField('LEGENDABLUE').element[0].style.color = 'blue';
    };

    var validaCampoCnpj = function(manifestacaoArgs) {
        var cnpj = manifestacaoArgs.owner.field.widget.getField("NRINSJURIEST");
        cnpj.readOnly = !manifestacaoArgs.row.CDEMPRESA;
        cnpj.setValue('');
        validaCampoInscricaoEstadual(manifestacaoArgs);
    };

    var validaCampoInscricaoEstadual = function(manifestacaoArgs) {
        var inscricaoEstadual = manifestacaoArgs.owner.field.widget.getField("CDINSCESTA");
        inscricaoEstadual.readOnly = !manifestacaoArgs.row.NRINSJURIEST;
        inscricaoEstadual.setValue('');
    };

    this.empresaOnChange = function(manifestacaoArgs) {
        validaCampoCnpj(manifestacaoArgs);
    };

    this.cnpjOnChange = function(manifestacaoArgs) {
        validaCampoInscricaoEstadual(manifestacaoArgs);
    };

    var getManifestacaoWidget = function(){
        if(templateManager.container)
            return templateManager.container.getWidget("manifestacao");
    };

    this.getCurrentField = function(field) {
        var manifestacaoWidget = getManifestacaoWidget();
        if (manifestacaoWidget)
            return !manifestacaoWidget.currentRow[field] ? null : manifestacaoWidget.currentRow[field];
    };

    var getFilterPopupCurrentRow = function(args){
        return args.e.preference.FILTER_ROW;
    };

    this.getEmpresaFiltrada = function(){
        var manifestacaoWidget = getManifestacaoWidget();
        if(manifestacaoWidget){
            return this.CDEMPRESA;
        }
    };
    
    this.setFilterFields = function(widget, field){
        field.dataSourceFilter.forEach(function(filter){
            if(widget.name == 'zhFilterPreferencesSelectConditions')
                filter.value = widget.currentRow[filter.name] || 'TD';
            else
                filter.value = widget.appliedFilter.FILTER_ROW[filter.name] || 'TD';
        });
        field.reload();
    };

    this.getFieldFromFilterPopup = function(field){
        var manifestacaoWidget = getManifestacaoWidget();
        if(manifestacaoWidget){
            var widgetAtiva = manifestacaoWidget.getParent().getActiveWidget();
            if(widgetAtiva.name == 'zhFilterPreferencesSelectConditions')
                return widgetAtiva.currentRow[field] || 'TD';
            else
                return manifestacaoWidget.appliedFilter.FILTER_ROW[field] || 'TD';
        }
    };

    this.idorigdestOnChange = function(filterArgs) {
        alteraVisibilidadeCampoInscricaoFiltro(filterArgs);
        limpaCamposOutDataSelectsTpOperacFiltro(filterArgs);
    };

    var alteraVisibilidadeCampoInscricaoFiltro = function(filterArgs) {
        var filtroWidget = filterArgs.owner.field.widget;
        var cliente = filtroWidget.getField("NMRAZSOCCLIE");
        var fornecedor = filtroWidget.getField("NMRAZSOCFORN");
        var filial = filtroWidget.getField("DSFILIEMIT");
        var tipoDestino = filterArgs.row.IDORIGDESTNF;

        switch (tipoDestino) {
            case "C":
                validacaoCamposOutTpOperacFilter(cliente, fornecedor, filial);
                break;
            case "F":
                validacaoCamposOutTpOperacFilter(fornecedor, cliente, filial);
                break;
            case "L":
                validacaoCamposOutTpOperacFilter(filial, fornecedor, cliente);
                break;
            default:
                filial.readOnly = true;
                cliente.readOnly = true;
                fornecedor.readOnly = true;
        }
    };

    var limpaCamposOutDataSelectsTpOperacFiltro = function(filterArgs)
    {
        var filtroWidget = filterArgs.owner.field.widget;
        var cabecalhoRow = filtroWidget.currentRow;
        var cliente = filtroWidget.getField("NMRAZSOCCLIE");
        var fornecedor = filtroWidget.getField("NMRAZSOCFORN");
        var filial = filtroWidget.getField("DSFILIEMIT");

        filial.value(null);

        cliente.value(null);
        cabecalhoRow.CDCLIENTE = null;

        fornecedor.value(null);
        cabecalhoRow.CDFORNECED = null;
        cabecalhoRow.IDSITUCADA = null;
        cabecalhoRow.IDBLQNFRELAFOAF = null;

        cabecalhoRow.NRINSJURNF = null;
        cabecalhoRow.NMINSJURNF = null;
        cabecalhoRow.IDTPINSJURNF = null;
    };

    var validacaoCamposOutTpOperacFilter = function(princialField) {
        princialField.showOnView = true;
        princialField.showOnForm = true;
        princialField.isVisible = true;
        princialField.readOnly = false;

        for (var i = 1; i < arguments.length; i++) {
            arguments[i].showOnView = false;
            arguments[i].showOnForm = false;
            arguments[i].isVisible = false;
            arguments[i].readOnly = true;
        }
    };

    this.criaDataSourceGridFilterBeforeApply = function(args) {
        args.e.preventDefault();
        var manifestacaoWidget = args.owner;

        
        if(manifestacaoWidget.isValid()) {
            var dataSourceFilter = manifestacaoWidget.dataSourceFilter;
            var currentRow       = args.e.preference.FILTER_ROW;
            this.CDEMPRESA          = currentRow.CDEMPRESA;
            this.CDINSCESTA         = currentRow.CDINSCESTA;
            
            dataSourceFilter = dataSourceFilter.filter(function(value) {
                return value.name !== 'P_DTEMISSAOINI' && value.name !== 'P_DTEMISSAOFIN' && (value.isCustomFilter !== true); 
            });

            var filterDefault = {
                'operator': '='
            };
            
            var datasFiltro = [{name: "DTEMISSAO"}];
            
            dataSourceFilter.forEach((data) => {
                if(data.name != 'DTEMISSAO' && data.name != 'P_IDENTRSAIDNF' && data.name != 'P_IDENTRSAIDOP') {
                    if(data.name == "P_NRINSJUREMIT") {
                        data.value = currentRow.NRINSJURNF || 'TD';
                    }
                    else {
                        data.value = currentRow[data.name.replace("P_", "")] || 'TD';
                    }
                }
            });
            datasFiltro.forEach(function(data) {
                filterDefault.name = 'P_' + data.name + 'INI';
                filterDefault.value = currentRow.DTEMISSAO.start;
                dataSourceFilter.push(Util.clone(filterDefault));
                filterDefault.name = 'P_' + data.name + 'FIN';
                filterDefault.value = currentRow.DTEMISSAO.end;
                dataSourceFilter.push(Util.clone(filterDefault));
    
                if(dataSourceFilter.indexOf(data) > 0)
                    dataSourceFilter.splice(dataSourceFilter.indexOf(data), 1);
            });
            manifestacaoWidget.dataSourceFilter = dataSourceFilter;
            manifestacaoWidget.reload().then(() => {
                manifestacaoWidget.activate();
            });
            ScreenService.closePopup();
        }
    };

    this.abrirPopupJustificativa = function(args){
        var notas = args.owner.widget.getCheckedRows().filter(function(notafiscal){
                    return !notafiscal.NRLANCTONF && notafiscal.IDSTATUSMANIF !== "3";
                });

        if(notas.length > 0){
            var popupJustificativa = args.owner.widget.container.getWidget('popupJustificativa');
            ScreenService.openPopup(popupJustificativa);
        }
        else{
            ScreenService.showMessage(messages.nenhumaNota);
        }
    };

    this.montaConfig = function(args){
        Dfe58000_ManifestacaoDestinatario_Service.montaConfigTransmissao(getFilterPopupCurrentRow(args)).then(function(resp){
        }, requestError);
        args.e.preference.CUSTOM_FILTER_ROW = {};
    };

    this.manifestarCiencia = function(args){
        var notas = args.owner.widget.getCheckedRows().filter(function(notafiscal){
            return (notafiscal.IDSTATUSMANIF === "0" || notafiscal.IDSTATUSMANIF === "5") && (notafiscal.IDSTATUSNFE != 2 && notafiscal.IDSTATUSNFE != 3);
        });
        
        var evento = '210210';
        var justificativa = '';

        if(notas.length > 0){
            ScreenService.confirmMessage(ScreenService.i18n(messages.confirmarOperacao), 'question', function (success) {
   
                Dfe58000_ManifestacaoDestinatario_Service.manifestarNfe(notas, evento, justificativa).then(function(callback){
                    if(callback[0].SUCESSO) ScreenService.showMessage(callback[0].SUCESSO);
                    else if(callback[0].ERRO) this.openPopupErros(callback[0].ERRO);
                    args.owner.widget.reload();
                }.bind(this), function(error) {
                    ScreenService.showMessage(error.data.error);
                    args.owner.widget.reload();
                });
            }.bind(this));
        }
        else{
            ScreenService.showMessage(messages.nenhumaNota);
        }
    };
    
    this.openPopupErros = function(erros) {
        var widgetErros = templateManager.container.getWidget('WidgetErros');
        widgetErros.dataSource.data = erros;
        widgetErros.isVisible = true;
        ScreenService.openPopup(widgetErros);
        widgetErros.activate();
    };
    
    this.closeErros = function(widget) {
        widget.isVisible = false;
        widget.dataSource.data = [];
        ScreenService.closePopup(widget);
        widget.getParent().activate();
        widget.getParent().unSelectAll();
        widget.getParent().reload();
        ScreenService.closePopup();
    };

    this.manifestarConfirmacao = function(args){
        var notas = args.owner.widget.getCheckedRows().filter(function(notafiscal){
                    return (notafiscal.IDSTATUSMANIF !== "1") && (notafiscal.IDSTATUSNFE != 2 && notafiscal.IDSTATUSNFE != 3);
                });
        var evento = '210200';
        var justificativa = '';

        if(notas.length > 0){
            ScreenService.confirmMessage(ScreenService.i18n(messages.confirmarOperacao), 'question', function (success) {
                Dfe58000_ManifestacaoDestinatario_Service.manifestarNfe(notas, evento, justificativa).then(function(callback){
                    if(callback[0].SUCESSO) ScreenService.showMessage(callback[0].SUCESSO);
                    else if(callback[0].ERRO) this.openPopupErros(callback[0].ERRO);
                    args.owner.widget.reload();
                }.bind(this), function(error) {
                    ScreenService.showMessage(error.data.error);
                    args.owner.widget.reload();
                });
            }.bind(this));
        }
        else{
            ScreenService.showMessage(messages.nenhumaNota);
        }
    };

    this.manifestarDesconhecimento = function(args){
        var notas = args.owner.widget.getCheckedRows().filter(function(notafiscal){
            return (!notafiscal.NRLANCTONF && notafiscal.IDSTATUSMANIF !== "2") && (notafiscal.IDSTATUSNFE != 2 && notafiscal.IDSTATUSNFE != 3);
        });
        
        var evento = '210220';
        var justificativa = '';

        if(notas.length > 0){	
            ScreenService.confirmMessage(ScreenService.i18n(messages.confirmaDesconhecimento), 'question', function (success) {
                Dfe58000_ManifestacaoDestinatario_Service.manifestarNfe(notas, evento, justificativa).then(function(callback){
                    if(callback[0].SUCESSO) ScreenService.showMessage(callback[0].SUCESSO);
                    else if(callback[0].ERRO) this.openPopupErros(callback[0].ERRO);
                    args.owner.widget.reload();
                }.bind(this), function(error) {
                    ScreenService.showMessage(error.data.error);
                    args.owner.widget.reload();
                });
            }.bind(this));
        }
        else{
            ScreenService.showMessage(messages.nenhumaNota);
        }
    };

    this.manifestarNaoRealizada = function(args){
        var notas = args.owner.widget.getParent().getCheckedRows().filter(function(notafiscal){
                    return (!notafiscal.NRLANCTONF && notafiscal.IDSTATUSMANIF !== "3") && (notafiscal.IDSTATUSNFE != 2 && notafiscal.IDSTATUSNFE != 3);
                });
        var evento = '210240';
        var justificativa = args.owner.widget.currentRow.JUSTIFICATIVA;

        if(!justificativa || justificativa.trim().length < 15){
            ScreenService.showMessage('Justificativa deve conter no mínimo 15 caracteres', 'ERROR');
        }
        else{
            if(notas.length != 0) {
                ScreenService.confirmMessage(ScreenService.i18n(messages.confirmaDesconhecimento), 'question', success => {
                    Dfe58000_ManifestacaoDestinatario_Service.manifestarNfe(notas, evento, justificativa).then( callback => {
                        ScreenService.closePopup();
                        if(callback[0].SUCESSO) ScreenService.showMessage(callback[0].SUCESSO);
                        else if(callback[0].ERRO) this.openPopupErros(callback[0].ERRO);
                        args.owner.widget.getParent().reload();
                    }, error => {
                        ScreenService.showMessage(error.data.error);
                        args.owner.widget.getParent().reload();
                    });
                });
            }
            else {
                ScreenService.showMessage(messages.nenhumaNota);
                ScreenService.closePopup();
                args.owner.widget.getParent().reload();
            }
            
        }
    };

    this.gerarXML = function(args){
        var notasMarcadas = args.owner.widget.getCheckedRows();
        var notas = notasMarcadas.filter(function(notafiscal){
            return notafiscal.IDSTATUSMANIF == "1" || notafiscal.IDSTATUSMANIF == "4";
        });
        
        if(notas.length > 0){

            Dfe58000_ManifestacaoDestinatario_Service.gerarXML(notas).then(function(response){
                 window.open(window.serviceUrls.filter(function(x){return x.package == 'df';})[0].baseUrl+"/downloadArquivo?requestType=Row&row[DSARQUIVO]=" + response.dataset.gerarXmlNfeManifestacao[0]);
            }, function(error) {
                ScreenService.showMessage(error.data.error);
            });
        }
        else{
            ScreenService.showMessage(messages.nenhumaNota);
        }
    };

    this.sincronizarNFe = function(widget){
        var manifesacao = templateManager.container.getWidget('manifestacao');
        widget.currentRow.CDEMPRESA  = this.CDEMPRESA;
        widget.currentRow.CDINSCESTA = this.CDINSCESTA;
        ScreenService.showLoader();
        Dfe58000_ManifestacaoDestinatario_Service.sincronizarNFe(widget.currentRow).then((callback) => {
            this.closePopupSincronizacao();
            ScreenService.successNotification("Sincronização Realizada com Sucesso!");
            widget.getParent().reload();
            this.openPopupResumo(callback);
            ScreenService.hideLoader();
        }, (error) => {
            ScreenService.errorNotification(error.data.error);
        });
        
    };
    
    this.openPopupResumo = function(sincronizacao) {
        var wdgResumo = templateManager.container.getWidget('RESUMOSINC');
        wdgResumo.isVisible = true;
        if(sincronizacao.dataset.sincronizarNfeManifestacao[0]) {
            wdgResumo.currentRow = sincronizacao.dataset.sincronizarNfeManifestacao[0].DADOS;
            wdgResumo.widgets[0].dataSourceFilter[0].value = sincronizacao.dataset.sincronizarNfeManifestacao[0].CHAVES; 
            wdgResumo.widgets[0].dataSourceFilter[0].operator = "IN";
            wdgResumo.widgets[0].reload();
            ScreenService.openPopup(wdgResumo);
        }
        
        
    };
    
    this.closePopupResumo = function() {
        var wdgSinc = templateManager.container.getWidget('RESUMOSINC');
        ScreenService.closePopup();
        wdgSinc.isVisible = false;
    };
    
    this.openPopupSincronizacao = function() {
        var wdgSinc = templateManager.container.getWidget('WidgetSincronizacao');
        wdgSinc.currentRow.FORMAPESQUISA    = "0";
        wdgSinc.isVisible = true;
        ScreenService.openPopup(wdgSinc);
    };
    
    this.closePopupSincronizacao = function() {
        var wdgSinc = templateManager.container.getWidget('WidgetSincronizacao');
        ScreenService.closePopup();
        wdgSinc.isVisible = false;
    };
    
    this.closePopup = function(widget) {
        widget.isVisible = false;
        widget.dataSource.data = [];
        ScreenService.closePopup(widget);
        widget.getParent().activate();
        widget.getParent().unSelectAll();
        widget.getParent().reload();
        ScreenService.closePopup();
    };
    
    this.openConsultaNsuNfe = function(widget) {
        var widgetNsu = templateManager.container.getWidget('popupConsultaNsu');
        widgetNsu.isVisible = true;
        
        Dfe58000_ManifestacaoDestinatario_Service.openConsultaNsuNfe(widget, widgetNsu);
    };
    
    this.closePopupNsuNfe = function(widget) {
        widget.isVisible = false;
        widget.widgets[0].dataSource.data = [];
        ScreenService.closePopup(widget);
        widget.getParent().activate();
        widget.getParent().unSelectAll();
        widget.getParent().reload();
    };
    
    this.onChangeDtRecbtoNsu = function(widget) {
        
        widget.widgets[0].dataSourceFilter[2].value = widget.currentRow.DTRECBTO.start;
        widget.widgets[0].dataSourceFilter[3].value = widget.currentRow.DTRECBTO.end;
        
        widget.widgets[0].reload();
    };

};
    

Configuration(function(ContextRegister) {
    ContextRegister.register("Dfe58000_ManifestacaoDestinatario_Controller", dfe58000_ManifestacaoDestinatario_Controller);
});